;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Note: input should always be in "aXb=" format where a and b are signed ints and X is the operator. Any spaces
;will cause the program to produce an Error message. Only use operators (+  -  *  /  %)
;If an error message is displayed, please try running the program again with better input. 
;For example try "4*8="      or "8%3="
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
INCLUDE Irvine32.inc
INCLUDE macros.inc


.data
num1      DWORD 0
num2      DWORD 0
plusMinus1 BYTE '+'
plusMinus2 BYTE '+'
overflowcounter DWORD 0
operator  BYTE ?
stringInput BYTE 35 DUP  (0) 
error1 BYTE "	BAD INPUT, run prog again to get correct results",0
error2 BYTE "	OVERFLOW",0

.code
main PROC

mov edx, OFFSET stringInput
mov ecx, SIZEOF stringInput
call ReadString
mov ecx,eax
mov esi,0
call retrieveChar ;Retrieves first character , whether it be a sign or a number
call checkElement ;Checks for the sign, then retrieves the first number
call retrieveChar ;Retrieves second character. whether it be sign or number
call checkElement2 ;Checks for the sign, then retrieves second number
call checkOperation ;Performs the operation (Note at the end of check Element, the operator was found and stored into operator

main ENDP


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
retrieveChar PROC ;Basically reads one character at a time, starting from the first character
mov al, stringInput[esi]
inc esi
ret
retrieveChar ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkElement PROC ;This part checks if the first char is a sign or a number
cmp al, '+'
je sign1
cmp al,'-'
je sign1
call IsDigit
jz n1

bad:             ;If the first char is neither, it will call the BadInput Function
call BadInput
exit

sign1:           ;registers the sign
mov plusMinus1,al
call retrieveChar
cmp al,30h
jb bad
cmp al,39h
jbe n1
jmp bad

n1:             ;Starts putting the digits together into one number in Eax
add overflowcounter,1
sub al,30h
mov ebx,0
mov bl,al
mov eax,num1
imul eax,10
add eax,ebx
mov num1, eax

call retrieveChar
call IsDigit    ;Checks if next char is a digit
jz n1
mov operator,al
cmp plusMinus1,'-' ;If the sign was negative originally, it will make sure num1 is negative after the whole number's absolute value is produced
jz negative
jmp end1          ; If not negative, jump to end
negative:
neg num1

end1:             ;Checks for overflow. Basically if the the number has more than 10 digits, it will over flow
cmp overflowcounter,10
ja bad
ret
checkElement ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkElement2 PROC     ;This function does the exact same thing as checkElement, but does it for the second number
mov overflowcounter,0
cmp al, '+'
je sign2
cmp al,'-'
je sign2
call IsDigit
jz n2

bad:
call BadInput
exit

sign2:
mov plusMinus2,al
call retrieveChar
cmp al,30h
jb bad
cmp al,39h
jbe n2
jmp bad

n2:
add overflowcounter,1
sub al,30h
mov ebx,0
mov bl,al
mov eax,num2
imul eax,10
add eax,ebx
mov num2, eax

call retrieveChar
call IsDigit
jz n2
cmp plusMinus2,'-'
jz negative
cmp al,'='
je end2
call BadInput
exit
negative:
neg num2

end2:
cmp overflowcounter,10
ja bad
ret
checkElement2 ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
checkOperation PROC ;This function does the arithmetic
 
 mov overflowcounter,0
 mov al,operator ;Checks the operator
       cmp al,'+'
       jz addition
       
       cmp al,'-'
       jz subtraction
       
       cmp al,'*'
       jz multiplication
       
       cmp al,'/'
       jz division
       
       cmp al,'%'
       jz remainder
       
       call BadInput ;if the operator is not one of those above, this is bad input
       exit
       
              addition:
       mov eax,num1
       add eax,num2
       call WriteInt
       jmp finishline
       
       subtraction:
       mov eax,num1
       sub eax,num2
       call WriteInt
       jmp finishline
       
       multiplication:
       mov eax,num1
       mov ebx,num2
       mul ebx
       call WriteInt
       jmp finishline
       
       division:
       mov eax,num1
       cdq
       mov ebx,num2
       idiv ebx
       call WriteInt
       jmp finishline
       
       remainder:
       mov eax,num1
       cdq
       mov ebx,num2
       idiv ebx
       mov eax,edx
       call WriteInt      
       finishline:
       ret
       
checkOperation ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
BadInput PROC
cmp overflowcounter,10 ;If the overflow counter is above 10, we have an over flow. Otherwise we just have bad input
ja overflow
mov edx, OFFSET error1
call WriteString
call Crlf
exit

overflow:
mov edx, OFFSET error2
call WriteString
call Crlf
exit
BadInput ENDP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

END main
